\version "2.24.0"

\header {
  texidoc = "
Other snippets show how to replace a breathe symbol by some other
symbol. This snippet extends that idea by:


* Changing the voice context so that all breathe symbols in the score
are replaced. * Using arbitrary text rather than just a symbol to
replace the breathe symbol.


In this example the breathe symbol is replaced by the comma character
from the Helvetica font. This character is enlarged and slightly raised
using the @code{\\raise} markup function.



"
  doctitle = "Changing breathe marks to markup text"
}
%% http://lsr.di.unimi.it/LSR/Item?id=640
%% see also http://www.lilypond.org/doc/v2.18/Documentation/notation/expressive-marks-as-curves


\layout {
  \context {
    \Voice
    \override BreathingSign.font-name = #"Helvetica"
    \override BreathingSign.font-size = #8
    \override BreathingSign.text = #(markup (#:raise 0.2 ","))
  }
}
\new Staff {
  \relative c'' {
    b4 b \breathe b b
  }
}


