\version "2.24.0"

\header {
  texidoc = "
There are two things you need to do to create arbitrary noteheads:

<p>1. change the NoteHead stencil to the text-interface.

<p>2. define the text attribute of the NoteHead. It accepts any markup.
The easiest thing to do is to simply call a musicglyph, as in this
example.

"
  doctitle = "Customising note heads"
}

%% http://lsr.di.unimi.it/LSR/Item?id=475
%% see also http://lilypond.org/doc/v2.18/Documentation/notation/note-heads

%LSR This snippet was contributed by Victor Adan

headCircle   = {
\once \override NoteHead.stencil = #ly:text-interface::print
\once \override NoteHead.text = #(markup #:musicglyph "scripts.flageolet" ) }

headPlus        = {
\once \override NoteHead.stencil = #ly:text-interface::print
\once \override NoteHead.text = #(markup #:musicglyph "scripts.stopped") }

{
  \headCircle
  c'4
  \headPlus
  d'4
  % normal
  e'4
}


