\version "2.24.0"

\header {
  texidoc = "
If you do not want to use lilypond's automatic barlines but rather just
insert barlines with \\bar, the bar counter will not be increased, and
therefore two problems may occur:

* accidentals will not be properly reset, * and the printed barnumber
will be wrong.

This snippet defines a function, \\increaseBarNumber that - yeah -
increases the barnumber, thereby making accidentals and typeset
barnumbers behave correctly. Just call it whenever you insert a manual
bar.Also defines short hand functions @code{\\ibar} and @code{\\nibar}
- as illustrated by the example. 

"
  doctitle = "Free Meter - increasing the barnumber wherever you want"
}

%% http://lsr.di.unimi.it/LSR/Item?id=333
%% see also http://lilypond.1069038.n5.nabble.com/LSR-v2-18-quot-Free-Meter-increasing-the-barnumber-quot-does-not-work-tc159360.html

\markup\magnify #1.5 "This snippet needs v2.18 upgrade"

% many thanks to Rune Zedeler for this snippet

%{
%%% BEGIN %%%
increaseBarNumber = \applyContext
#(lambda (x)
  (let ((measurepos (ly:context-property x 'measurePosition)))
   ; Only increase bar number if not at start of measure.
   ; This way we ensure that you won't increase bar number twice
   ; if two parallel voices call increaseBarNumber simultanously:
   (if (< 0 (ly:moment-main-numerator measurepos)) ; ugh. ignore grace part
    (begin
     (ly:context-set-property!
      (ly:context-property-where-defined x 'internalBarNumber)
      'internalBarNumber
      (1+ (ly:context-property x 'internalBarNumber)))
     (ly:context-set-property!
      (ly:context-property-where-defined x 'currentBarNumber)
      'currentBarNumber
      (1+ (ly:context-property x 'currentBarNumber)))
     ; set main part of measurepos to zero, leave grace part as it is:
     (ly:context-set-property!
      (ly:context-property-where-defined x 'measurePosition)
      'measurePosition
      (ly:make-moment 0 1
       (ly:moment-grace-numerator measurepos)
       (ly:moment-grace-denominator measurepos)))))))

% Named Increasing BAR
nibar = #(define-music-function (x) (string?)
#{
  \bar $x
  \increaseBarNumber
#})

% Increasing BAR
ibar = \nibar "|"

{
  \new Staff \with { \remove Time_signature_engraver } {
    \cadenzaOn
    \accidentalStyle modern-cautionary
    \key a \major
    \repeat unfold 2 {
      c'8 dis' eis'  eis' \ibar
      c'4 dis'  e' eis' \nibar "||"
      c' dis' eis'8 dis' eis' \ibar
      c'1 dis' eis' eis'2 \nibar "|."
    }
  }
}
%%% END %%% 
%}

