\version "2.24.0"

\header {
  texidoc = "
Whilst staves can be grouped and nested using a variety of notations,
such as @code{SystemStartSquare} or @code{SystemStartBrace} (which can
be achieved automatically through the
@code{systemStartDelimiterHierarchy} property), some editions of
symphonic music use SystemStartBracket at different levels, which may
result in unwanted collision between bracket tips.

Here is a possible workaround, which masks the extraneous part of some
bracket tips in order to give the impression that they merge with the
lower-level bracket.



"
  doctitle = "Merging nested system start brackets"
}

maskUpperTip =
#(lambda (grob)
   (let ((mask (ly:round-filled-box '(-1 . 1.25) '(.42 . 2) 0)))
     (ly:stencil-stack
      (ly:system-start-delimiter::print grob)
      Y UP
      (ly:make-stencil
       (list 'color white (ly:stencil-expr mask))))))

maskLowerTip =
#(lambda (grob)
   (let ((mask (ly:round-filled-box '(-1 . 1.25) '(-1.5 . -.4) 0)))
     (ly:stencil-stack
      (ly:system-start-delimiter::print grob)
      Y DOWN
      (ly:make-stencil
       (list 'color white (ly:stencil-expr mask))))))

\markup {
  \score {
    \new StaffGroup  <<
      \new StaffGroup \with {
        \override SystemStartBracket.extra-offset = #'(0.6 . 0) 
      } <<
        \new Staff { c'^\markup \rotate #-90 ":-(" }
        \new Staff { d' }
      >>
      \new Staff { e' }
    >>
    \layout {}
  }
  "    "
  \score {
    \new StaffGroup  <<
      \new StaffGroup \with {
        \override SystemStartBracket.stencil = \maskUpperTip
        \override SystemStartBracket.extra-offset = #'(0.6 . 0)
      } <<
        \new Staff { c'^\markup \rotate #-90 ":-)" }
        \new Staff { d' }
      >>
      \new Staff { e' }
    >>
    \layout {}
  }
  "    "
  \score {
    \new StaffGroup  <<
      \new Staff { c'^\markup \rotate #-90 ":-)" }
      \new StaffGroup \with {
        \override SystemStartBracket.stencil = \maskLowerTip
        \override SystemStartBracket.extra-offset = #'(0.6 . 0)
      } <<
        \new Staff { d' }
        \new Staff { e' }
      >>
    >>
    \layout {}
  }
}

