\version "2.24.0"

\header {
  texidoc = "
For some instruments such as bagpipes it is desirable to use groups of
several gracenotes that do not stretch with the normal music. This can
be achieved by setting the @code{GraceSpacing spacing-increment} to
zero or to a small value.

"
  doctitle = "Non-stretchable gracenote groups"
}

%% http://lsr.di.unimi.it/LSR/Item?id=740
%% see also http://lilypond.org/doc/v2.18/Documentation/notation/special-rhythmic-concerns

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% LSR workaround:
#(set! paper-alist (cons '("snippet" . (cons (* 180 mm) (* 60 mm))) paper-alist))
\paper {
  #(set-paper-size "snippet")
  indent = 0
  tagline = ##f
}
\markup\vspace #.5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%here starts the snippet:

\relative c' {
  c4 c_"Normally" \grace { g'32[ c, g' c, g'] } c,4 c |
  c4 c c c | \break
  c4 c_"With tweak applied"
  \override Score.GraceSpacing.spacing-increment = #0
  \grace { g'32[ c, g' c, g'] } c,4 c |
  c4 c c c
}

\layout {
  \context {
    \Score
    \omit BarNumber
  }
}



