\version "2.24.0"

\header {
  texidoc = "
By default, only the piece and opus fields from the
@code{\\header@{...@}} block are typeset above each separate score, if
you have multiple @code{\\score@{...@}} blocks in your input file.

As explained in the Notation Reference, you can change this by setting
the paper variable  printallheaders, so that the full title is printed
over each score. The corresponding @code{\\header@{...@}} block should
then be included within the corresponding @code{\\score@{...@}} block, 
otherwise you will get an additional title (the title for the full
book) above the first  individual score title. This example shows how
to get rid of the extra book level title.  Note that a top level
@code{\\header@{...@}} block is useful if some titling information is
the  same for all scores and you do not want to repeat the information
several times in the  input file.



"
  doctitle = "Printing the full title on several scores in the same file"
}

%% http://lsr.di.unimi.it/LSR/Item?id=310
%% see also http://lilypond.org/doc/v2.18/Documentation/notation/creating-titles-headers-and-footers

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% LSR workaround:
#(set! paper-alist (cons '("snippet" . (cons (* 180 mm) (* 100 mm))) paper-alist))
\paper {
  #(set-paper-size "snippet")
  %indent = 0
  tagline = ##f
}
\markup\vspace #.5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%here starts the snippet:

%LSR: Thanks to Adam James Wilson for this snippet

\header {
  composer = "The One and Only"
}

\score{
  { c' d' e' f'}
  \header{
    title = "First piece"
  }
}

\score{
  { c' d' e' f'}
  \header{
    title = "Second piece"
  }
}

\paper{
  print-all-headers=##t
  bookTitleMarkup = ##f
}


