\version "2.24.0"

\header {
  texidoc = "
Sometimes the spacing is too tight, so that a fall or doit looks almost
vertical.  The solution is to specify a minimum length for the
fall/doit, but only setting the @code{minimum-length} property (which
you can do on hairpins and slurs, for example) does not work, since you
also need a suitable setting for the @code{springs-and-rods} property.
This example shows how to do it.

"
  doctitle = "Setting the minimum length of a fall/doit"
}

%% http://lsr.di.unimi.it/LSR/Item?id=899
%% see also http://www.lilypond.org/doc/v2.18/Documentation/notation/expressive-marks-as-curves#falls-and-doits
\markup \vspace #1 %% LSR-problem-workaround

noteFix = {
  \once \override BendAfter.springs-and-rods = #ly:spanner::set-spacing-rods
  \once \override BendAfter.minimum-length = #5
}

\relative c' {
  f2.~ f8
  \noteFix
  f-\bendAfter #-4 |
  r2 r8 c d f |
}






